
package Theme;

require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(navbar navbar2);

use CGI qw/ :standard :html3 /;
use CGI dd, dt, dl, ul, li, center;

my $fsglnfdir = "@FSGLNFDIR@";

my @index = ( [ 0, './', 'Home' ],
	      [ 1, 'http://www.linux-foundation.org/en/OpenPrinting/LPorgWikiTest', '<b>Test the Wiki!</b>' ],
	      [ 1, 'news.html', 'News' ],
	      [ 1, 'database.html', 'Database' ],
	      [ 2, 'printer_list.cgi', 'Printer Listings' ],
	      [ 2, 'driver_list.cgi', 'Driver Listings' ],
	      [ 1, 'foomatic.html', 'Foomatic' ],
	      [ 2, 'cups-doc.html', 'CUPS QuickStart' ],
	      [ 2, 'ppd-doc.html', 'PPD Docs' ],
	      [ 2, 'lpd-doc.html', 'LPD Docs' ],
	      [ 2, 'pdq-doc.html', 'PDQ Docs' ],
	      [ 2, 'ppr-doc.html', 'PPR Docs' ],
	      [ 2, 'direct-doc.html', 'No Spooler Docs' ],
	      [ 1, 'forums.cgi', 'Forums' ],
	      [ 1, 'tutorial.html', 'Tutorial' ],
	      [ 1, 
		'/kpfeifle/LinuxKongress2002/Tutorial/VII.cups-help/VII.cups-help.html', 
		'CUPS Help!' ],
#	      [ 2,
#		'/kpfeifle/LinuxKongress2002/Tutorial/I.LinuxKongress-2002-kdeprint/', 
#		'KDE Print' ],
#	      [ 2, 
#		'/kpfeifle/LinuxKongress2002/Tutorial/III.PostScript-and-PPDs/III.PostScript-and-PPDs.html', 
#		'PostScript/PPDs' ],
	      [ 1, 'indexdoc.html', 'Other Docs' ],
	      [ 1, 'indexfaq.html', "FAQ's" ],
	      [ 1, 'articles.html', 'Articles' ],
	      [ 1, 'projects.html', 'Projects' ],
	      [ -1, '', '<br>' ],
	      [ 0, '/macosx/', 'Mac OS X' ],
	      [ -1, '', '<br>' ],
	      [ 0, 'about.html', 'About this site' ],
	      [ 0, 'contribute.html', 'Contributing' ],
	      [ -1, '', '<br>' ],
	      [ 0, 'http://www.picante.com/~gtaylor/', 'Grant Taylor' ],
	      [ 0, 'http://www.openprinting.org/till/', 'Till Kamppeter' ],
	     );

my $googlestat = '<!-- Code added for Google Analytics-->
<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
</script>
<script type="text/javascript">
_uacct = "UA-831873-2";
urchinTracker();
</script>';

sub getfile {
    my ($filename) = @_;
    open F, $filename or return undef;
    my @content = <F>;
    close F;
    return join('', @content);
}

sub outputtext {
    my ($text) = @_;
    print $text;
}

sub replacetoken {
    my ($text, $token, $reptext) = @_;
    $text =~ s/<\$$token\$>/$reptext/g;
    return $text;
}

sub parsetext {
    my ($text, $section) = @_;
    $text =~ /<\%$section(.*?)\%>/gs;
    my $match = $1;
    return ($match ? $match : undef);
}

sub includefile {
    my ($text) = @_;
    $text =~ s!<\?(.*?)\?>!getfile("$fsglnfdir/$1.html")!egs;
    return $text;
}

sub buildmenu {
    my ($level, $menu, $active) = @_;
    my $html;
    my $itemhtml = getfile($fsglnfdir . "/level_" . $level . "_link.html");
    my $activehtml = getfile($fsglnfdir . "/level_" . $level .
			     "_link_active.html");
    foreach my $menuentry (@{$menu}) {
	my $temp =
	    ($menuentry->[0] eq $active ? $activehtml : $itemhtml) . "\n";
	$temp = replacetoken($temp, "menutext", $menuentry->[0]);
	$temp = replacetoken($temp, "menuurl", $menuentry->[1]);
	$html .= $temp;
    }
    return $html;
}

sub fsgwebpage {
    
    use lib "@FSGLNFDIR@";
    @USELFWEB@

    # TODO: active menu items level 1: Workgroup
    # TODO: portlets?
    my ($loc, $title, @body) = @_;
    my $docTitle = "OpenPrinting database - $title";
    my $output;
    $output .= join('', fsg_head_elements()); 
     $output .= join('', fsg_header()); 
      $output .= join('', fsg_body_start()); 
       $output .= join('', fsg_content_start($docTitle)); 
        $output .= join('', fsg_content_block_start()); 
         $output .= join('', @body); 
        $output .= join('', fsg_content_block_end()); 
       $output .= join('', fsg_content_end()); 
      $output .= join('', fsg_body_end()); 
     $output .= join('', fsg_footer());

    $output .= $googlestat;

    return $output;
}

sub navbar {
    my ($loc, @body) = (@_);

    if ($loc eq 'driver') {
	return navbar2('driver_list.cgi',
		       'Foomatic Printer Support Database',
		       @body);
    } elsif ($loc eq 'printer') {
	return navbar2('printer_list.cgi',
		       'Foomatic Printer Support Database',
		       @body);
    } else {
	return navbar2('foo',
		       'Foomatic Printer Support Database',
		       @body);
    }
}



sub navbar2 {
    my ($loc, $title, @body) = (@_);

    return fsgwebpage($loc, $title, @body) if ( -d $fsglnfdir );

    my @idxhtml;
    my $idxelem;
    for $idxelem (@index) {
	my ($indent, $link, $text) = @{$idxelem};
	
	if ($indent == -1) {
	    push (@idxhtml, $text);
	} else {
	    while ($indent--) {
		push (@idxhtml, '&nbsp;&nbsp;');
	    }
	    $text =~ s/ /\&nbsp;/g;
	    if ($link ne $loc) {
		push (@idxhtml, "<a href=\"$link\">");
	    } else {
		push (@idxhtml, '<b>');
	    }
	    push (@idxhtml, $text);
	    if ($link ne $loc) {
		push (@idxhtml, '</a>');
	    } else {
		push (@idxhtml, '</b>');
	    }
	    push (@idxhtml, '<br>');
	}
    }

    return table({cellspacing=>0,
		  cellpadding=>6,
		  border=>0,
		  width=>'100%'},
		 Tr(td({align=>'center',BGCOLOR=>'#ffffff'},
		       table({cellspacing=>0, cellpadding=>3, border=>0},
			     Tr(td('<img src="logo.png">'),
				td(font({size=>'+0'},'Linux<br>Printing<em>.org</em>'))))),
		    td({BGCOLOR=>'#ffffff'},
		       font({size=>'+3'}, $title))),
		 Tr(td({valign=>'top',
			BGCOLOR=>'#72D397',
			height=>'100%'},
		       font({size=>'-1'}, join('', @idxhtml)),
		       p({align=>'center'}, '<a href="http://www.linux-foundation.org/"><img src="fsg-logo.gif" border="0"></a>'),
		       td({valign=>'top', height=>'100%', width=>'100%'},
			  # header p(), could go here
			  join('', @body))))) . $googlestat;
}


1;
