#! /usr/bin/perl

my $wdir = "@WIKISHDIR@";

use CGI qw/ :standard :html3/;# -debug/;
use CGI escape, unescape, font, center;
use PHTDB qw/$hcache/;

use Theme qw/navbar2/;

my $query = new CGI;

# Check for special format request
my $id = $query->param('id');
die if $id =~ m!\.\.!;
die if $id =~ m!\,!;

if ($id =~ m!^(\w+)\:([\d\w\-\.\_]+)$!) {

    my ($key, $subkey) = ($1, $2);

    my $basev = $query->param('basev');
    die if $basev =~ m![^\d\.]!; # not a filename, a cvs version number

    my $input = $query->param('input');
    # arbitrary data written to file and checked in, not a cmd arg, etc

    my $dataentered = $query->param('dataentered');
    # was text input submitted?

    # if no file, make one
    chdir $wdir;
    if (! -f "$id,v") {
	sysrun("rcs -t/dev/null -i '$id'");
	chmod 0664, "$id,v";
	sysrun("touch '$id'");
	chmod 0664, "$id";
	sysrun("ci -r '$id'") or die;
	chmod 0664, "$id,v";
    }

    # figure out navbar loc key
    my $navloc;
    if ($key eq 'prose') {
	$navloc = "$subkey.html";
    } elsif ($key eq 'printer') {
	$navloc = "show_printer.cgi";
    } else {
	$navloc = $key;
    }

    if (!$dataentered) {
	# find head version
	my @form;
	my @input;
	my $head = '1.1';
	open PIPE, "rlog -b '$id'|" or die;
	while (<PIPE>) {
	    next unless m/^head: ([\d\.]+)/;
	    $head = $1;
	}
	close PIPE or die;
	
	if (!$basev) {
	    $basev = $head;
	}

	open PIPE, "co -r$basev -p '$id'|" or die;
	@starterinput = <PIPE>;
	close PIPE or die;

	# return basic form with basev + input
	grep { s/\&/\&amp;/g; s/\</&lt;/g; } @starterinput;
	my $oldinput = join(//,@starterinput);
	$oldinput =~ s/^\s+//;
	$oldinput =~ s/\s+$//;
	push(@form,
	     '<form method="POST" action="edit.cgi">',
	     '<input type="hidden" name="basev" value="' . "$head" . '">',
	     '<input type="hidden" name="id" value="' . "$id" . '">',
	     '<input type="hidden" name="dataentered" value="' . "1" . '">',
	     '<textarea name="input" rows=36 cols=78 wrap=off style="font-family: monospace">' .
	     $oldinput .
	     '</textarea><br>',
	     '<input type="submit">',
	     '</form>');

	my (@forform, @backform);
	if ($basev =~ m!([\d]+)\.(\d+)$!) {
	    my ($maj, $min) = ($1, $2);
	    my $nx = sprintf("$maj.%d", $min+1);
	    my $pr = sprintf("$maj.%d", $min-1);

	    push(@backform,
		 '<form method="POST" action="edit.cgi">',
		 '<input type="hidden" name="basev" value="' . "$pr" . '">',
		 '<input type="hidden" name="id" value="' . "$id" . '">',
		 '<input type="submit" value="Start from previous">',
		 '</form>');
	    push(@forform,
		 '<form method="POST" action="edit.cgi">',
		 '<input type="hidden" name="basev" value="' . "$nx" . '">',
		 '<input type="hidden" name="id" value="' . "$id" . '">',
		 '<input type="submit" value="Start from next">',
		 '</form>');
	}
	print (
	       header(-expires=>'-15m', -type=>'text/html; charset=UTF-8'),
	       start_html(-title=>"Edit $id"),
	       navbar2($navloc,
		       'Foomatic Wikish',
		       ($key eq 'prose' ? p(a({href=>"prose.cgi?id=$subkey"},"Back to $id"))
			: $key eq 'printer' ? p(a({href=>"show_printer.cgi?recnum=$subkey"},"Back to $id"))
			: ''),
		       p("Editing comments for $id:"),
		       @form,
		       hr(),
		       ($basev eq '1.1' ? '' : @backform), ($basev eq $head ? '' : @forform)),
	       end_html()
	       );

	exit(0);

    } else {
	my $now = time();
	my $comment = sprintf("ip=%s", $ENV{'REMOTE_ADDR'});

	my @inputsplit = split(m/\n/, $input);
	my $inputlinect = scalar(@inputsplit);
	my $urllinesct = scalar(grep(m/tp\:\/\//i, @inputsplit));
	if ($urllinesct and $inputlinect / $urllinesct lt 10) {
	    warn "Suspicious url:lines ratio $urllinesct:$inputlinect input:\n$input";
	    print "Location: show_printer.cgi?recnum=$subkey\r\n\r\n";
	    exit (0);
	}
	    
	# submission lock, verify basev, checkin/unlock
	my $head = undef;
	unlink($id);
	if (sysrun("co -l '$id'")) {
	    open PIPE, "rlog -b '$id'|" or die;
	    while (<PIPE>) {
		next unless m/^head: ([\d\.]+)/;
		$head = $1;
	    }
	    close PIPE or die;

	    if ($head eq $basev) {
		# ok, check it in!
		$input =~ s/^\s+//;
		$input =~ s/\s+$//;

		open PRV, "co -p '$id'|";
		my @prv = <PRV>;
		close PRV;

		my $oldinput = join(//,@prv);
		$oldinput =~ s/^\s+//;
		$oldinput =~ s/\s+$//;
		
		if ($oldinput ne $input) {
		    open TMP, ">$id.$$" or die "tmpfile open error";
		    print TMP $input;
		    close TMP;
		    rename "$id.$$", "$id" or die "rename error";
		    chmod 0664, "$id";
		    sysrun("ci -m'$comment' -r '$id'") or die "checkin error";
		    chmod 0664, "$id,v";
		    sysrun("rcs -u '$id'");
		    unlink($id);
		} else {
		    # same as current version!
		    sysrun("rcs -u '$id'");
		    unlink($id);
		}
		
		if ($key eq 'printer') {
		    unlink("$hcache/show-printer-recnum-$subkey.html")
			if (-d $hcache);
		    print "Location: show_printer.cgi?recnum=$subkey\r\n\r\n";
		    exit (0);
		} elsif ($key eq 'prose') {
		    unlink("$hcache/prose-$subkey.html")
			if (-d $hcache);
		    print "Location: prose.cgi?id=$subkey\r\n\r\n";
		    exit (0);
		} else {
		    die "bogus key $key";
		}
	    } else {
		# Doh! Merge needed...

		# unlock, unlink gfile, etc, etc
		sysrun("rcs -u '$id'");
		unlink($id);

		open PIPE, "co -r$head -p '$id'|" or die;
		@starterinput = <PIPE>;
		close PIPE or die "error getting $id revision $head";
		grep { s/\&/\&amp;/g; s/\</&lt;/g; } @starterinput;
		my $oldinput = join(//,@starterinput);
		$oldinput =~ s/^\s+//;
		$oldinput =~ s/\s+$//;

		push(@form,
		     '<form method="POST" action="edit.cgi">',
		     '<input type="hidden" name="basev" value="' . "$head" . '">',
		     '<input type="hidden" name="id" value="' . "$id" . '">',
		     '<input type="hidden" name="dataentered" value="' . "1" . '">',
		     '<textarea name="input" rows=12 cols=78 wrap=off style="font-family: monospace">' . 
		     $oldinput .
		     '</textarea>',
		     '<input type="submit">',
		     '</form>');

		my @originput = $input;
		grep { s/\&/\&amp;/g; s/\</&lt;/g; } @originput;

		print 
		    header(-expires=>'-15m', -type=>'text/html; charset=UTF-8'),
		    start_html(-title=>"Edit $id"),
		    navbar2($navloc,
			    'Foomatic Wikish',
			   ($key eq 'prose' ? p(a({href=>"prose.cgi?id=$subkey"},"Back to $id"))
			    : $key eq 'printer' ? p(a({href=>"show_printer.cgi?recnum=$subkey"},"Back to $id"))
			    : ''),
			   p('Oops, someone edited under you!  The current version is in',
			     'the text box below, and the version you submitted is below',
			     'that.  Please edit your changes into the new text and resubmit.'),
			   @form,
			   hr(),
			   pre(@originput)),
		    end_html()
			;
		exit(0);
	    }

	    die 'should be impossible to get here';
	} else {
	    # Doh! Locked!
	    @starterinput = ($input);

	    # return basic form with basev + input
	    grep { s/\&/\&amp;/g; s/\</&lt;/g; } @starterinput;
	    push(@form,
		 '<form method="POST" action="edit.cgi">',
		 '<input type="hidden" name="basev" value="' . "$basev" . '">',
		 '<input type="hidden" name="id" value="' . "$id" . '">',
		 '<input type="hidden" name="dataentered" value="' . "1" . '">',
		 '<textarea name="input" rows=12 cols=78 wrap=off style="font-family: monospace">' . 
		 join(//, @starterinput) .
		 '</textarea>',
		 '<input type="submit">',
		 '</form>');

	    print 
		header(-expires=>'-15m', -type=>'text/html; charset=UTF-8'),
		start_html(-title=>"Edit $id"),
		navbar2($navloc,
			'Foomatic Wikish',
		       ($key eq 'prose' ? p(a({href=>"prose.cgi?id=$subkey"},"Back to $id"))
			: $key eq 'printer' ? p(a({href=>"show_printer.cgi?recnum=$subkey"},"Back to $id"))
			: ''),
		       p("Whoops, temporarily locked (or broken?), please try again!"),
		       @form),
		end_html()
		    ;

	    exit(0);
	}
    }
}

die;

sub sysrun {
    my $r = system @_;
    return (0 == ($r / 256));
}

exit 0;
