#! /usr/bin/perl

use Theme qw/navbar/;
use CGI qw/ :standard :html3 /;
use CGI escape, unescape, font, center;
use lib "@LIBDIR@";
use Foomatic::DB qw/normalizename/;

#sub navbar {
#    return @_;
#}

my $ua = $ENV{'HTTP_USER_AGENT'};
my $query = new CGI;
my $dbh;

# Check for special format request
my $driver = $query->param('driver');
my $poid   = $query->param('printer');

# Carefully check inputs for validity - we hate escape codes and junk,
# as they might cause weirdness in regexps.
if (($poid =~ m!^[\d\w\_\-\.]+$!) and ($driver =~ m!^[\d\w\-\.\_]+$!)) {

    # Do we have an old numerical printer ID or an otherwise renamed or
    # aliased printer? If so, bounce to the correct printer ID.
    my $newid = Foomatic::DB::translate_printer_id($poid);
    if ($newid ne $poid) {
	print redirect("execution.cgi?driver=$driver&printer=$newid");
	exit(0);
    }

    # Get all the data about this driver/printer pair
    my $db = new Foomatic::DB;
    my $dat = $db->getdat($driver, $poid);

    # Generate HTML Documentation about how to use this driver with the
    # chosen printer
    my @execdocs = $db->getexecdocs();

    my $printer = "$dat->{'make'} $dat->{'model'}";

    ## Now, construct a web page

    if ($#execdocs < 0) {
	push(@execdocs,
	     p("Insufficient information about driver execution."));
    }

    # Construct the whole page
    my @body;
    push(@body,
	 #h2("$driver"),
	 h3("Execution of the driver \"$driver\" on the $printer"),
	 p("This describes how the driver \"$driver\" is used with the $printer. It shows the command line which is used when setting up this printer/driver combo with Foomatic. The command line expects PostScript as standard input and produces a data format understood by the printer as standard output. This description contains all options available for the driver and also some driver-independent extra-options (as PJL options), you don't need to supply all of them to be able to print."),
	 p(@execdocs));

    $| = 1;
    print header(-expires=>'-15m', -type=>'text/html; charset=UTF-8');
    print 
	start_html(-title => "Execution Details for \"$driver\" with the $printer",
		   -author => 'Till Kamppeter',
		   -BGCOLOR => 'white'),
	navbar('driver',
	       p(a({href=>"./"},"Linux Printing Home Page."),
		 br(),
		 a({href=>"printer_list.cgi"},
		   "Support Database intro page."),
		 br(),
		 a({href=>"driver_list.cgi"},
		   "All Drivers."),
		 br(),
		 a({href=>"show_driver.cgi?driver=$driver"},
		   "Back to the \"$driver\" driver page."),
		 br(),
		 a({href=>"show_printer.cgi?recnum=$poid"},
		   "Printer page for the $printer.")),
	       @body),
	end_html();

}

exit 0;
