#! /usr/bin/perl

use Theme qw/navbar/;
use CGI qw/ :standard :html3 /;
use CGI super, escape, unescape, font, center, dd, dt, dl, ul, li, blink;

use PHTDB qw/normalizename $hcache $cachedir/;

my $ua = $ENV{'HTTP_USER_AGENT'};
my $query = new CGI;

# Connect to the database
my $db = new PHTDB;
my $overfile = "$cachedir/pcache/overview.perl";
$db->{'overviewfile'} = $overfile;

# Fetch list of printers
my $over = $db->get_overview();
my $p;
for $p (@$over) {
    my ($make, $model, $id) = ($p->{make}, $p->{model}, $p->{id});

    my @refers;
    my $skukey;
    for $skukey ($db->get_skus($id)) {

	if ($skukey =~ m!^([^:]+):([\-\%\w\d\/]+)!) {
	    my ($vend, $sku) = ($1, $2);
	    
	    my $flavor = undef;
	    my $literal = 0;
	    if ($vend =~ s!([\{\(])(.+)[\)\}]!!) {
		$flavor = $2;
		$literal = 1 if $1 eq '{';
	    }
	    my $text = "$make $model$flavor";
	    $text = $flavor if $literal;
	    my $vendname = $db->get_sku_vendor($vend);
	    my $instock = $db->get_sku_stock($skukey);
	    my $stockstr = $instock ? '' : em(' but out of stock');
	    my $price = $db->get_sku_price($skukey);
	    my $pricenum = $price;
	    $pricenum =~ s![\$\,]!!g;
	    my $pricestr = sprintf("%.2f", $pricenum);
	    push(@html, 
		 $db->get_sku_link($vend, $sku, $text),
		 " $pricestr $stockstr $vendname id $id sku $sku ",
		 (defined($price) ? "" : "<font color=red>DEAD</font>"),
		 br());
	}
    }
}


print (header(-expires=>'-15m', -type=>'text/html; charset=UTF-8'), 
       start_html, 
       @html,
       end_html);
