#! /usr/bin/perl

# Example only; I actually think it would be bad to replace the bulk
# of the prose with wikish.  I just needed to generalize the code so I
# can do other things wikish...

use Theme qw/navbar2/;
use CGI qw/ :standard :html3/;
use CGI escape, unescape, font, center;

use lib "@LIBDIR@";
use PHTDB qw/$hcache $cachedir/;

my $wikishdir = "@WIKISHDIR@";
my $query = new CGI;

# Which prose page?
my $subkey = $query->param('id');
die if $subkey =~ m!\.\.!;
die if $subkey =~ m!\,!;

if ($subkey =~ m!^([\d\w\-\.\_]+)$!) {
    my ($key, $id) = ('prose', "prose:$subkey");
    
    # OK, is there a cached page?
    my $cachepage = "$hcache/prose-$subkey.html";

    my @output = ();
    if (-f $cachepage) {
	for (my $i = 0; $i < 20; $i++) {
	    open CFILE, $cachepage or die "error opening $cachepage";
	    my $o = join('', <CFILE>);
	    close CFILE;
	    # Only output the cashed page if it was really completely written
	    # Before introduction of this measure pages would not display due
	    # to an incomplete cache file until the next page rebuild (or
	    # until manually nuking the cache).
	    if ($o =~ m!</html>\s*$!s) {
		@output = ($o);
		last;
	    }
	    # If we have non-empty output, the other process is already
	    # writing the cache file or there is definitely written a broken
	    # cache. Retry only once in this case.
	    $i = 18 if $o;
	    sleep 10;
	}
    }
    if (!@output) {
	# Open cache file already now to tell concurrent processes that we are
	# already computing this case
	umask 0002;
	if (! -d $hcache) {
	    mkdir $hcache or warn "Could not mkdir $hcache";
	    chmod 2775, $hcache;
	}
	die "Error writing $cachepage\n" if !(open CFILE, "> $cachepage");

	die unless -f "$wikishdir/$id,v";

	my $modtime = (stat(_))[9];

	open PIPE, "co -p '$wikishdir/$id' |" or die;
	my @wtxt = <PIPE>;
	close PIPE or die;

	# need html scrubber!

	# Parse and interpret the ".content" genpage preprocessor format
	my ($title, $desc, @body);
	my $l;

      k: while ($l = shift(@wtxt)) {
	    if ($l =~ m!^\%(\w+)\%!) {
		my $k = $1;
		my @v = ();
	      v: while ($l=shift(@wtxt)) {
		    if ($l !~ m!^\%\w+\%!) {
			push(@v, $l);
			next v;
		    } else {
			unshift(@wtxt, $l);
			if ($k eq 'title') {
			    $title = join(' ', @v);
			    $title =~ s/[\r\n]/ /g;
			} elsif ($k eq 'description') {
			    $desc = join(' ', @v);
			    $desc =~ s/[\r\n]/ /g;
			} elsif ($k eq 'body') {
			    push(@body, @v);
			} else {
			    warn "dud %% key $k in id $id";
			    push(@body, @v);
			}
			next k;
		    }
		}
		if ($k eq 'body') {
		    push(@body, @v);
		}
	    } else {
		push (@body, $l);
	    }
	}

	push (@output,
	      start_html(-title => $title,
			 -author => 'Grant Taylor & Till Kamppeter',
			 -meta=> { 'description' => $desc },
			 -BGCOLOR => 'white'),
	      navbar2("$subkey.html",
		      $title,
		      @body,
		      font({size=>'-1'},
			   p("Last modified", sprintf("%s.", scalar(gmtime($modtime))),
			     br(),
			     a({href=>"edit.cgi?id=$id"}, '[Edit this page]'),
			     a({href=>"wikish-history.cgi?id=$id&scale=31"}, '[Wikish history]'))),
		      ),
	      end_html());
	
	# Write preparsed web page cache
	if ($cachepage) {
	    print CFILE @output;
	    close CFILE;
	} else {
	    warn "unable to write $cachepage";
	}

    }

    print header(-expires=>'-15m', -type=>'text/html; charset=UTF-8'), @output;
}

exit 0;
