#
# Recipe for Genpage that allows for easy formatting of HTML text in HTML
# It is mainly used to format examples for recipes, but I guess it could
# also be modified to display any kind of HTML.
#
# The HTML must be passed in as the parameter. The easiest way is, to pass in
# a complete section by using the content() function for that.
#
# As a second parameter, maybe the file name of a theme might be interesting.
#
# This recipe now uses the new-style recipe() directive - to load it, use :
# <!-- recipe( "displayHTML.gp" ) -->
#

# Clean up the name space
#if (defined(&displayHTML)) { undef &displayHTML };

sub displayHTML {
  my $Result = strip( shift );

  my $cmt_start = "<!" . "--";
  my $cmt_end = "--" . ">";

  my $HTMLPrefix = "<TABLE width=\"100%\" bgcolor=#E8E8E8><TR><TD><CODE>\n";
  my $HTMLPostfix = "\n</CODE></TD></TR></TABLE>";

  my $CommentPrefix = "<FONT color=gray>";
  my $CommentPostfix = "</FONT>";

  my $GenpagePrefix = "<FONT color=blue>";
  my $GenpagePostfix = "</FONT>";

  my $AMPcharPrefix = "<FONT color=magenta>";
  my $AMPcharPostfix = "</FONT>";

  # Fix all meta-chars
  $Result =~ s/&/&amp;/sg;
  $Result =~ s/</&lt;/sg;
  $Result =~ s/>/&gt;/sg;
  $Result =~ s/"/&quot;/sg;
  $Result =~ s/\n/<BR>\n/sg;

  # Now fix the leading spaces on a line
  while ($Result =~ /^(\s*)\s/m) {
    $Result =~ s/^(\s*)\s/$1&nbsp/m;
  };

  # Now fix all comments to be in italics
  $Result =~ s/(&lt;!--.*?--&gt;)/$CommentPrefix$1$CommentPostfix/sg;

  # And highlight all Genpage comments
  $Result =~ s/$CommentPrefix(&lt;!--\s*_GP_.*?--&gt;)$CommentPostfix/$GenpagePrefix$1$GenpagePostfix/sgi;

  # And highlight the special characters (&...; stuff)
  $Result =~ s!(&amp;\w+;)!$AMPcharPrefix$1$AMPcharPostfix!sig;

  # Append header and footer
  $Result = $HTMLPrefix . $Result . $HTMLPostfix;

  return $Result;
};

return "<!-- Using displayHTML.gp -->";