# By max.maischein@econsult.de

# Simple system to create "download urls" for files.
# To use, put <!-- _GP_ recipe("download.gp") --> into the page

#
# Usage is as follows :
# In your page (or wherever appropriate) use 
#   <-- _GP_ dl_file( "filename" ) -->
# to create something in the lines of <A HREF="filename">filename</A>(xxx k)
# or use
#   <-- _GP_ dl_file( "filename", "Description" ) -->
# to create something like <A HREF="filename">Description</A>(xxx k)
# or use
#   <-- _GP_ dl_file( "filename", "Description", "filesize" ) -->
# to create something like <A HREF="filename">Description</A>(filesize k)
# (most useable for non-local urls etc.
#

use File::stat;

	sub dl_file {
	  my $target = shift;
	  my $description = shift || $target;
	  my $filesize = shift;
	  my $result;

	  $result = "<A href=\"$target\">$description</A>";
	  if (!defined($filesize)) {
  	    if (!($target =~ m!://!)) {
	    # It's a local url
	      my $basedir = $inputfile;
	      $basedir =~ s!/[^/]*$!!;
	      my $targetfilename = build_path( $basedir, $target );
	      if (-f $targetfilename ) {
	        $st = stat( $targetfilename );
	        ($filesize = $st->size / 1024) =~ s/(.[0-9]*)?$/ k/;
	      } else {
		$filesize = "unknown";
	      };
	    } else {
	      $filesize = "unknown";
	    };
	    $filesize = "(" . $filesize . ")";
	  } else {
	    $filesize = "($filesize)";
	  };
	  $result .= " " . $filesize;
	  return( $result );
	};
return "<!-" . "- Using download.gp -" . "->"
