# By max.maischein@econsult.de
#
# Simple recipe to create proper width= and height= attributes
# for <IMG> tagse
# To use, put <!-- _GP_ recipe("gifsize.gp") --> into the page
#
# Usage is as follows :
# In your page (or wherever appropriate) use 
#   <-- _GP_ img("picture.gif") -->
# to create something like <IMG src="picture.gif" width="x" height="y">
#
#   <-- _GP_ img("picture.gif","A nice picture") -->
# to create something like <IMG src="picture.gif" alt="A nice picture" width="x" height="y">
#
#   <-- _GP_ img("picture.gif","Some alternative text","border=\"0\"") -->
# to create something like <IMG src="picture.gif" alt="Some alternative text" border="0" width="x" height="y">
#
# The path to the image must always be a relative path (relative to content/ !)
#
	sub img {
	  my $imagename = shift;
          my $alt = shift || "";
	  my $attributes = shift || "";
          my $Width = 0;
          my $Height = 0;
          my $ID;

	  $alt =~ s/(.+)/ alt=\"$1\" /;

	  my $result;
	  my $absdir;
	  ($absdir = $inputfile) =~ s!/[^/]*$!/!;
	  my( $absname ) = build_path( $absdir, $imagename );

	  if ($imagename =~ /\.gif$/i) {
            # Extract GIF size
	    #print "\n$imagename\n";
            open FILE, "<$absname" || die "opening \"$absname\" : $! \n";
            binmode FILE;
	    my $buffer; my $ID;
	    my $bytes = read( FILE, $buffer, 10 );
            die "reading from \"$imagename\" : $! \n" unless (defined($bytes));
            close FILE;
            ($ID, $Width, $Height) = unpack( "A6SS", $buffer );
          } elsif ($imagename =~ /\.jpe?g$/i) {
	    # Extract JPeG size
            open FILE, "<$absname" || die "opening \"$absname\" : $! \n";
            binmode FILE;
	    my $buffer;
            my $ID;
	    my $bytes = read( FILE, $buffer, 2048 );
            die "reading from \"$imagename\" : $! \n" unless (defined($bytes));
            close FILE;

            my $SOF = pack("CC", 0xFF, 0xC0 );
	    #print "*$SOF*";
            if ($buffer =~ /$SOF...(....)/ ) {
              $buffer = $1;
              ($Height,$Width ) = unpack( "nn", $buffer );
            } else { print "imgsize:JPeG:No SOF header found"};  
          } else {
 	      print "\nUnknown file extension for image : $imagename (ignored)";
          };

          if (defined( $Width ) && defined( $Height )) {
            #print "(${Width}x$Height)";
            $attributes .= " width=\"$Width\" height=\"$Height\"";
          };

          $result .= "<IMG src=\"$imagename\"" . $alt . $attributes . ">";
	  return( $result );
	};
return "<!-" . "- Using thumbnail.gp -" . "->"
