#
# This recipe calculates relative paths to the root of the web tree
#
# Submitted by Karl Heinz Kremer khk@khk.net  (24/05/1999)
# 
# initialisation: put <!-- _GP_ require($root/include/relPath.gp) --> in one 
# of the parsed files e.g. your template.
#
# use: <!-- _GP_ relPath("path") -->
# 
sub relPath {
	my $path = shift;
	my $outdir = $opt_o;
	my $outfile = $outputfile;

	$outdir =~ s!//+!/!g;		# substitute // with /
	$outfile =~ s!//+!/!g;		# substitute // with /
	$outfile =~ s|$outdir||g; # strip leading dir

	# convert this filename into a relativ path to the root of the current
	# directory hirarchy
	#
	# /index.html -> ./
	# /abcdef/index.html -> ../
	# /abcd/efg/index.html -> ../../

	$outfile =~ s/[^\/]//g;	# remove all non '/' characters
	chop($outfile);
	$outfile =~ s/\//\.\.\//g;
	$outfile = "./" . $outfile . $path;

	return $outfile;
}

return ("<!-- Genpage recipe relPath included -->");
